{}// Beta version
{*************************************************************************}
{ GH Freebrary                                                            }
{                                                                         }
{ GHFDataSetEventHolder.pas - TghDataSetEventHolder class unit.           }
{                                                                         }
{ This software is distributed under the open source BSD license.         }
{                                                                         }
{ Copyright (c) 2002-2013, Al Gonzalez (rescatandoadelphi.blogspot.com)   }
{ All rights reserved.                                                    }
{                                                                         }
{ Redistribution and use in source and binary forms, with or without      }
{ modification, are permitted provided that the following conditions are  }
{ met:                                                                    }
{                                                                         }
{   - Redistributions of source code must retain the above copyright      }
{     notice, this list of conditions and the following disclaimer.       }
{   - Redistributions in binary form must reproduce the above copyright   }
{     notice, this list of conditions and the following disclaimer in the }
{     documentation and/or other materials provided with the              }
{     distribution.                                                       }
{   - Neither the name of Al Gonzalez nor the names of his contributors   }
{     may be used to endorse or promote products derived from this        }
{     software without specific prior written permission.                 }
{                                                                         }
{ THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS }
{ IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED   }
{ TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A         }
{ PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT      }
{ HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,  }
{ SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT        }
{ LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,   }
{ DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY   }
{ THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT     }
{ (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE   }
{ OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.    }
{*************************************************************************}

{ Please contribute to improve this library.  I am not a good programmer,
  but good programmers know what Delphi is worth.

  A.G. }

Unit GHFDataSetEventHolder;  { Data Set Event Holder }

Interface

  Uses
    Classes, DB;

  Type
    { Data Set Event Holder class }
    TghDataSetEventHolder = Class (TComponent)
      Protected
        { Fields }
        FAfterCancel :TDataSetNotifyEvent;
        FAfterClose :TDataSetNotifyEvent;
        FAfterDelete :TDataSetNotifyEvent;
        FAfterEdit :TDataSetNotifyEvent;
        FAfterInsert :TDataSetNotifyEvent;
        FAfterOpen :TDataSetNotifyEvent;
        FAfterPost :TDataSetNotifyEvent;
        FAfterRefresh :TDataSetNotifyEvent;
        FAfterScroll :TDataSetNotifyEvent;
        FBeforeCancel :TDataSetNotifyEvent;
        FBeforeClose :TDataSetNotifyEvent;
        FBeforeDelete :TDataSetNotifyEvent;
        FBeforeEdit :TDataSetNotifyEvent;
        FBeforeInsert :TDataSetNotifyEvent;
        FBeforeOpen :TDataSetNotifyEvent;
        FBeforePost :TDataSetNotifyEvent;
        FBeforeRefresh :TDataSetNotifyEvent;
        FBeforeScroll :TDataSetNotifyEvent;
        FOnCalcFields :TDataSetNotifyEvent;
        FOnDeleteError :TDataSetErrorEvent;
        FOnEditError :TDataSetErrorEvent;
        FOnFilterRecord :TFilterRecordEvent;
        FOnNewRecord :TDataSetNotifyEvent;
        FOnPostError :TDataSetErrorEvent;
      Public
        { Virtual methods }
        Procedure DoAfterCancel (Sender :TDataSet); Virtual;
        Procedure DoAfterClose (Sender :TDataSet); Virtual;
        Procedure DoAfterDelete (Sender :TDataSet); Virtual;
        Procedure DoAfterEdit (Sender :TDataSet); Virtual;
        Procedure DoAfterInsert (Sender :TDataSet); Virtual;
        Procedure DoAfterOpen (Sender :TDataSet); Virtual;
        Procedure DoAfterPost (Sender :TDataSet); Virtual;
        Procedure DoAfterRefresh (Sender :TDataSet); Virtual;
        Procedure DoAfterScroll (Sender :TDataSet); Virtual;
        Procedure DoBeforeCancel (Sender :TDataSet); Virtual;
        Procedure DoBeforeClose (Sender :TDataSet); Virtual;
        Procedure DoBeforeDelete (Sender :TDataSet); Virtual;
        Procedure DoBeforeEdit (Sender :TDataSet); Virtual;
        Procedure DoBeforeInsert (Sender :TDataSet); Virtual;
        Procedure DoBeforeOpen (Sender :TDataSet); Virtual;
        Procedure DoBeforePost (Sender :TDataSet); Virtual;
        Procedure DoBeforeRefresh (Sender :TDataSet); Virtual;
        Procedure DoBeforeScroll (Sender :TDataSet); Virtual;
        Procedure DoOnCalcFields (Sender :TDataSet); Virtual;
        Procedure DoOnDeleteError (Sender :TDataSet; E :EDatabaseError;
          Var Action :TDataAction); Virtual;
        Procedure DoOnEditError (Sender :TDataSet; E :EDatabaseError;
          Var Action :TDataAction); Virtual;
        Procedure DoOnFilterRecord (Sender :TDataSet; Var Accept :Boolean);
          Virtual;
        Procedure DoOnNewRecord (Sender :TDataSet); Virtual;
        Procedure DoOnPostError (Sender :TDataSet; E :EDatabaseError;
          Var Action :TDataAction); Virtual;
      Published
        { Event properties }
        Property AfterCancel :TDataSetNotifyEvent Read FAfterCancel
          Write FAfterCancel;
        Property AfterClose :TDataSetNotifyEvent Read FAfterClose
          Write FAfterClose;
        Property AfterDelete :TDataSetNotifyEvent Read FAfterDelete
          Write FAfterDelete;
        Property AfterEdit :TDataSetNotifyEvent Read FAfterEdit
          Write FAfterEdit;
        Property AfterInsert :TDataSetNotifyEvent Read FAfterInsert
          Write FAfterInsert;
        Property AfterOpen :TDataSetNotifyEvent Read FAfterOpen
          Write FAfterOpen;
        Property AfterPost :TDataSetNotifyEvent Read FAfterPost
          Write FAfterPost;
        Property AfterScroll :TDataSetNotifyEvent Read FAfterScroll
          Write FAfterScroll;
        Property AfterRefresh :TDataSetNotifyEvent Read FAfterRefresh
          Write FAfterRefresh;
        Property BeforeCancel :TDataSetNotifyEvent Read FBeforeCancel
          Write FBeforeCancel;
        Property BeforeClose :TDataSetNotifyEvent Read FBeforeClose
          Write FBeforeClose;
        Property BeforeDelete :TDataSetNotifyEvent Read FBeforeDelete
          Write FBeforeDelete;
        Property BeforeEdit :TDataSetNotifyEvent Read FBeforeEdit
          Write FBeforeEdit;
        Property BeforeInsert :TDataSetNotifyEvent Read FBeforeInsert
          Write FBeforeInsert;
        Property BeforeOpen :TDataSetNotifyEvent Read FBeforeOpen
          Write FBeforeOpen;
        Property BeforePost :TDataSetNotifyEvent Read FBeforePost
          Write FBeforePost;
        Property BeforeRefresh :TDataSetNotifyEvent Read FBeforeRefresh
          Write FBeforeRefresh;
        Property BeforeScroll :TDataSetNotifyEvent Read FBeforeScroll
          Write FBeforeScroll;
        Property OnCalcFields :TDataSetNotifyEvent Read FOnCalcFields
          Write FOnCalcFields;
        Property OnDeleteError :TDataSetErrorEvent Read FOnDeleteError
          Write FOnDeleteError;
        Property OnEditError :TDataSetErrorEvent Read FOnEditError
          Write FOnEditError;
        Property OnFilterRecord :TFilterRecordEvent Read FOnFilterRecord
          Write FOnFilterRecord;
        Property OnNewRecord :TDataSetNotifyEvent Read FOnNewRecord
          Write FOnNewRecord;
        Property OnPostError :TDataSetErrorEvent Read FOnPostError
          Write FOnPostError;
    End;

Implementation

  { TghDataSetEventHolder }

  { Public virtual methods }

  Procedure TghDataSetEventHolder.DoAfterCancel (Sender :TDataSet);
  Begin
    If Assigned (AfterCancel) Then
      AfterCancel (Sender);
  End;

  Procedure TghDataSetEventHolder.DoAfterClose (Sender :TDataSet);
  Begin
    If Assigned (AfterClose) Then
      AfterClose (Sender);
  End;

  Procedure TghDataSetEventHolder.DoAfterDelete (Sender :TDataSet);
  Begin
    If Assigned (AfterDelete) Then
      AfterDelete (Sender);
  End;

  Procedure TghDataSetEventHolder.DoAfterEdit (Sender :TDataSet);
  Begin
    If Assigned (AfterEdit) Then
      AfterEdit (Sender);
  End;

  Procedure TghDataSetEventHolder.DoAfterInsert (Sender :TDataSet);
  Begin
    If Assigned (AfterInsert) Then
      AfterInsert (Sender);
  End;

  Procedure TghDataSetEventHolder.DoAfterOpen (Sender :TDataSet);
  Begin
    If Assigned (AfterOpen) Then
      AfterOpen (Sender);
  End;

  Procedure TghDataSetEventHolder.DoAfterPost (Sender :TDataSet);
  Begin
    If Assigned (AfterPost) Then
      AfterPost (Sender);
  End;

  Procedure TghDataSetEventHolder.DoAfterRefresh (Sender :TDataSet);
  Begin
    If Assigned (AfterRefresh) Then
      AfterRefresh (Sender);
  End;

  Procedure TghDataSetEventHolder.DoAfterScroll (Sender :TDataSet);
  Begin
    If Assigned (AfterScroll) Then
      AfterScroll (Sender);
  End;

  Procedure TghDataSetEventHolder.DoBeforeCancel (Sender :TDataSet);
  Begin
    If Assigned (BeforeCancel) Then
      BeforeCancel (Sender);
  End;

  Procedure TghDataSetEventHolder.DoBeforeClose (Sender :TDataSet);
  Begin
    If Assigned (BeforeClose) Then
      BeforeClose (Sender);
  End;

  Procedure TghDataSetEventHolder.DoBeforeDelete (Sender :TDataSet);
  Begin
    If Assigned (BeforeDelete) Then
      BeforeDelete (Sender);
  End;

  Procedure TghDataSetEventHolder.DoBeforeEdit (Sender :TDataSet);
  Begin
    If Assigned (BeforeEdit) Then
      BeforeEdit (Sender);
  End;

  Procedure TghDataSetEventHolder.DoBeforeInsert (Sender :TDataSet);
  Begin
    If Assigned (BeforeInsert) Then
      BeforeInsert (Sender);
  End;

  Procedure TghDataSetEventHolder.DoBeforeOpen (Sender :TDataSet);
  Begin
    If Assigned (BeforeOpen) Then
      BeforeOpen (Sender);
  End;

  Procedure TghDataSetEventHolder.DoBeforePost (Sender :TDataSet);
  Begin
    If Assigned (BeforePost) Then
      BeforePost (Sender);
  End;

  Procedure TghDataSetEventHolder.DoBeforeRefresh (Sender :TDataSet);
  Begin
    If Assigned (BeforeRefresh) Then
      BeforeRefresh (Sender);
  End;

  Procedure TghDataSetEventHolder.DoBeforeScroll (Sender :TDataSet);
  Begin
    If Assigned (BeforeScroll) Then
      BeforeScroll (Sender);
  End;

  Procedure TghDataSetEventHolder.DoOnCalcFields (Sender :TDataSet);
  Begin
    If Assigned (OnCalcFields) Then
      OnCalcFields (Sender);
  End;

  Procedure TghDataSetEventHolder.DoOnDeleteError (Sender :TDataSet;
    E :EDatabaseError; Var Action :TDataAction);
  Begin
    If Assigned (OnDeleteError) Then
      OnDeleteError (Sender, E, Action);
  End;

  Procedure TghDataSetEventHolder.DoOnEditError (Sender :TDataSet;
    E :EDatabaseError; Var Action :TDataAction);
  Begin
    If Assigned (OnEditError) Then
      OnEditError (Sender, E, Action);
  End;

  Procedure TghDataSetEventHolder.DoOnFilterRecord (Sender :TDataSet;
    Var Accept :Boolean);
  Begin
    If Assigned (OnFilterRecord) Then
      OnFilterRecord (Sender, Accept);
  End;

  Procedure TghDataSetEventHolder.DoOnNewRecord (Sender :TDataSet);
  Begin
    If Assigned (OnNewRecord) Then
      OnNewRecord (Sender);
  End;
  
  Procedure TghDataSetEventHolder.DoOnPostError (Sender :TDataSet;
    E :EDatabaseError; Var Action :TDataAction);
  Begin
    If Assigned (OnPostError) Then
      OnPostError (Sender, E, Action);
  End;

End.
